(*
    ===========================================================================

    R_CAO̐ƔjĎAKɃpXNX

    ---------------------------------------------------------------------------

    2004/02/02  n

    ===========================================================================
*)

unit iChii;

interface

uses
    Windows, Messages, Classes, Contnrs, SysUtils, Forms, ShlObj, StrUtils,
    ActiveX, dlgs, Winsock, iMisc;


type
    //  bZ[Wo̓Cxg
    TMessageOut = procedure(AMsg: string) of object;

    //  _CAO\
    PTargetInfo = ^TTargetInfo;
    TTargetInfo = record
        Handle   : HWND;        //  _CAÕnh
        WndText  : string;      //  _CAÕeLXg
        PathItem : WORD;        //  Ώۂ̕i(edt1  cmb13)
        TypeStr  : string;      //  X^C̕\p
        Parent   : string;      //  Av
    end;

    //  _CAO\̐pێNX
    TTargetList = class
    private
        FList       : TList;
        function    GetItem(WH: HWND; var Index: integer): PTargetInfo;
        procedure   DeleteByIndex(Index: integer);
    public
        constructor Create();
        destructor  Destroy(); override;
        function    Add(WH: HWND): integer;
        procedure   DeleteByHandle(WH: HWND);
        function    GetLast(): PTargetInfo;
    end;

    //  CNX
    TClickHereItIs = class
    private
        FWndHandle  : HWND;
        FEnabled    : Boolean;

        FHWndSList  : TStringList;
        FTargets    : TTargetList;

        FPreHandle  : HWND;
        FPrePath    : string;

        procedure   WndProc(var Msg: TMessage); virtual;

        procedure   DoTargetCreate(WH: HWND);
        procedure   DoTargetHack();
        procedure   DoTargetDestroy(WH: HWND);

    public
        constructor Create();
        destructor  Destroy; override;
        procedure   Start();
        procedure   Stop();

        property    Handle: HWND read FWndHandle;
    published

    end;

var
    MSG_OUT_LVL_1: TMessageOut;
    MSG_OUT_LVL_2: TMessageOut;

const
    //  ʒmpEBhEbZ[W(DLL to ClickHereItIs)
    UM_CREATEWND   = WM_APP + 1000; //  CBTProc(in DLL)
    UM_DESTROYWND  = WM_APP + 1001; //  CBTProc(in DLL)
    UM_MOUSEACTION = WM_APP + 1002; //  MouseProc(in DLL)

    //  DLL
    HOOK_DLL_NAME  = 'hook.dll';

    //  _CAO
    DLG_CLASS_NAME = '#32770';

    //  dNh~pGUID
    GUID_MAIN = '{438E4ED7-A433-4026-91B4-4A14A83C7E6E}';

implementation

var
    WinSockIsActive: Boolean;

(*
    ===========================================================================
    DLLC|[gEăX^eBbNN
    ===========================================================================
*)
function    HookInstall(Wnd: HWND): Boolean; stdcall;external HOOK_DLL_NAME;
procedure   HookUnInstall(); stdcall;external HOOK_DLL_NAME;
procedure   HookInitialize(); stdcall;external HOOK_DLL_NAME;
procedure   HookFinalize(); stdcall;external HOOK_DLL_NAME;




(*
    ===========================================================================
    Open/SaveAs_CAOǂ()
    ---------------------------------------------------------------------------
    http://www1.harenet.ne.jp/cgi-bin/cgiwrap/unaap/chtml/chtml.cgi?key=comdlg1
    http://www.interq.or.jp/www-user/wanderer/program/memo/msdn_jp/
           User_Interface_Services/Windows_User_Interface/User_Input/
           Common_Dialog_Box_Library/Common_Dialog_Box_Library_Overviews/
           OpenAndSaveAsDialogBoxes.html
    ===========================================================================
*)
function    CheckDialogItem(WH: HWND): WORD;
var
    Check: HWND;
begin
    Result := 0;

    //  ȉɋWƎvRg[ĂOK

    Check := GetDlgItem(WH, stc1);         //  lst1Xg{bNX̃x
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, stc2);         //  t@C̎(&T)
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, stc3);         //  t@C(&N)
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, stc4);         //  t@C̏ꏊ(&I)
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, cmb2);         //  t@C̏ꏊIR{
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, lst1);         //  Xgr[
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, chx1);         //  ǎpt@CƂĊJ(&R)`FbN
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, cmb1);         //  t@C̎ޑIR{
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, pshHelp);      //  uwvvR}h{^
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, IDOK);         //  J(&O){^
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, IDCANCEL);     //  LZ{^
    if (Check = 0) then Exit;

    //  OldStyleRv[g
    Check := GetDlgItem(WH, edt1);         //  t@C̓GfBbg
    if (Check <> 0) then Result := edt1;

    //  ExplorerX^CRv[g
    Check := GetDlgItem(WH, cmb13);        //  ݂̃t@C̖O\
    if (Check <> 0) then Result := cmb13;
end;

(*
    ===========================================================================
    tH_łȂǂ
    ---------------------------------------------------------------------------
    http://www.geocities.co.jp/SiliconValley-SanJose/6898/tips_clsid.htm
    http://www.hidecnet.ne.jp/~sinzan/tips/win/win_tip24.htm
    ===========================================================================
*)
function    CheckSpecial(APath: string): string;

    function    SlashedStr(AStr: string): string;
    begin
        Result := '/' + AStr + '/';
    end;

begin
    Result := APath;
    //  ȂI
    if (Result = '') then Exit;
    //  ʂɑ݂tH_Ȃʂ
    if DirectoryExists(APath) then Exit;
    //  fXNgbvłȂH
    if AnsiContainsText(ClickConfig.DeskTop, SlashedStr(Result)) then
    begin
        Result := GetDeskTopPath();
    end
    else
    //  }CRs[^łȂH
    if AnsiContainsText(ClickConfig.MyComputer, SlashedStr(Result)) then
    begin
        Result := '::{20D04FE0-3AEA-1069-A2D8-08002B30309D}';
    end
    else
    //  }Clbg[NłȂH
    if AnsiContainsText(ClickConfig.MyNetwork, SlashedStr(Result)) then
    begin
        Result := '::{208D2C60-3AEA-1069-A2D7-08002B30309D}';
    end
    else
    //  lbg[N\[XłȂH
    if WinSockIsActive and (gethostbyname(PChar(Result)) <> nil) then
    begin
        Result := '\\' + Result;
        if (Result = '\\') then Result := '';   //  ̂XȂ̂őΏǗÖ@
    end
    else
    //  ǂłȂ̂...
    begin
        Result := '';
    end;
end;

(*
    ===========================================================================
    GNXv[̃AhX擾
    ---------------------------------------------------------------------------
    http://hp.vector.co.jp/authors/VA020801/lnkpg/sample/getexp.txt
    http://hp.vector.co.jp/authors/VA009712/take/delphi/kabeapp.htm
    ===========================================================================
*)
function    GetExploreAddress(Awh: HWND): string;
var
    Buf: array[0..255] of Char;
    WH: HWND;
begin
    Result := '';
    //  WorkerW EBhE
    WH := FindWindowEx(Awh, 0, 'WorkerW', nil);
    if (WH <> 0) then
    begin
        //  ReBarWindow32 EBhE  
        WH := FindWindowEx(WH, 0, 'ReBarWindow32', nil);
        if (WH <> 0) then
        begin
            //  ComboBoxEx32 EBhE
            WH := FindWindowEx(WH, 0, 'ComboBoxEx32', nil);
            if (WH <> 0) then
            begin
                //  ̃eLXg擾
                FillChar(Buf, SizeOf(Buf), #0);
                SendMessage(WH, WM_GETTEXT, SizeOf(Buf), Integer(@Buf));
                Result := Buf;
                //  ȃtH_BɑΉ
                Result := CheckSpecial(Result);
            end;
        end;
    end;
end;

(*
    ===========================================================================
    }EXfXNgbvɂꍇɃfXNgbvւ̃pXԂ
    }EXtH_ɂꍇɂ̃tH_ւ̃pXԂ
    }EXGNXv[ɂꍇɂ̃tH_ւ̃pXԂ
    }EX悭Ȃꏊɂꍇɂ͋󕶎Ԃ
    ---------------------------------------------------------------------------
    http://hp.vector.co.jp/authors/VA020801/lnkpg/sample/getexp.txt
    http://hp.vector.co.jp/authors/VA009712/take/delphi/kabeapp.htm
    ===========================================================================
*)
function    GetFullPathOfMouse(var AResult: string): boolean;
var
    WndClassName: string;
    WH: HWND;
    Point: TPoint;
begin
    AResult := '';
    //  }EX̃EBhËԓVӂ̐eEBhẼnh
    GetCursorPos(Point);
    WH := GetMostTopLevelWindow(WindowFromPoint(Point));
//    WH := GetMostTopLevelWindow(WindowFromPoint(Mouse.CursorPos));
    //  ̃EBhẼNX
    WndClassName := GetClassNameStr(WH);
    //  fobO
    Application.MainForm.Caption := WndClassName;
    //  tH_
    if (WndClassName = 'CabinetWClass') then
    begin
        Sleep(ClickConfig.Wait4Cabinet);
        AResult := GetExploreAddress(WH);
    end
    else
    //  GNXv[
    if (WndClassName = 'ExploreWClass') then
    begin
        Sleep(ClickConfig.Wait4Explore);
        AResult := GetExploreAddress(WH);
    end
    else
    //  fXNgbv
    if (WndClassName = 'Progman') then
    begin
        AResult := GetDeskTopPath();
    end;
    //  łȂ?
    Result := (AResult <> '');
end;

(*
    ===========================================================================
    _CAOɃpXύXĂ݂
    ---------------------------------------------------------------------------
    http://www.kumei.ne.jp/c_lang/sdk4/sdk_301.htm
    http://forum.nifty.com/fdelphi/samples/00908.html
    ---------------------------------------------------------------------------
    http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=27
    http://www.interq.or.jp/www-user/wanderer/program/memo/msdn_jp/
           User_Interface_Services/Windows_User_Interface/User_Input/
           Common_Dialog_Box_Library/Common_Dialog_Box_Library_Overviews/
           OpenAndSaveAsDialogBoxes.html
    ===========================================================================
*)
procedure   SetDialogPath(WH: HWND; Path: string; APathItem: WORD);
var
    EditWH, OkWH: HWND;
    Buf: array[0..255] of Char;
    PreText: string;
begin
    //  EditRg[
    EditWH := GetDlgItem(WH, APathItem);
    //  ̕obNAbvĂ
    FillChar(Buf, SizeOf(Buf), #0);
    SendMessage(EditWH, WM_GETTEXT, SizeOf(Buf), Integer(@Buf));
    PreText := Buf;
    //  
    SendMessage(EditWH, WM_SETTEXT, 0, Longint(PChar(Path)));
    //  ΂҂
    Sleep(ClickConfig.Wait4OK);
    //  OK{^
    OkWH := GetDlgItem(WH, IDOK);
    //  OK{^
    SendMessage(OkWH, BM_CLICK, 0, 0);
    //  ɖ߂
    SendMessage(EditWH, WM_SETTEXT, 0, Longint(PChar(PreText)));
end;

(*
    ===========================================================================
    w肵AvOʂɎĂ
    ---------------------------------------------------------------------------
    [Delphi:80703] Re: OɃANeBuEBhEɂ
    http://homepage2.nifty.com/woodensoldier/computer/BCBTips.htm
    ===========================================================================
*)
procedure   BringToFront(ATarget: HWND);
var
    FGHWnd: HWND;
    TargetPID: DWORD;
    ForegroundPID: DWORD;
begin
    //  ɍőOʂɗĂȂ悵
    FGHWnd := GetForegroundWindow;
    if (FGHWnd = ATarget) then Exit;

    //  vZXID擾
    TargetPID     := GetWindowThreadProcessID(FGHWnd, nil);
    ForegroundPID := GetWindowThreadProcessID(ATarget, nil);
    //  őOʂ
    try
        AttachThreadInput(ForegroundPID, TargetPID, true);
        SetForegroundWindow(ATarget);
        AttachThreadInput(ForegroundPID, TargetPID, false);
    except
        ;
    end;
end;









(*
    ===========================================================================
    _CAO\̐pێNX
    ===========================================================================
*)

//  -----------------------------------------------------------------
//  \
function    InfoToStr(Item: PTargetInfo): string; overload;
begin
    Result := Format('HWND:%10d[%s] | TEXT:%s | OWNER:%s',
                     [Item^.Handle, Item^.TypeStr, Item^.WndText, Item^.Parent]);
end;

//  -----------------------------------------------------------------
//  nhɂACeǉ
function    TTargetList.Add(WH: HWND): integer;
var
    WndTxt  : string;
    PathItem: WORD;
    TypeStr : string;
    Parent  : string;
    ParentWH: HWND;
    MsgStr  : string;
    Item    : PTargetInfo;
begin
    Result := -1;
    //  ̃_CAÕeLXg
    WndTxt   := GetWindowTextStr(WH);
    //  ̃_CAO̕ҏWΏۃACe(0 Ȃ^[QbgłȂ)
    PathItem := CheckDialogItem(WH);
    //  _CAÕX^C
    if (PathItem = 0) then
        TypeStr := '...'
    else
    if (PathItem = edt1) then
        TypeStr := 'OLD'
    else
        TypeStr := 'EXP'
    ;
    //  ̃_CAO̎
    ParentWH := GetParent(WH);
    Parent   := GetWindowTextStr(ParentWH);
    //  \
    MsgStr := Format('[DLG_CAME] HWND:%10d', [WH]);
    if Assigned(MSG_OUT_LVL_2) then MSG_OUT_LVL_1(MsgStr);
    //  ^[Qbgł?
    if (PathItem = 0) then exit;
    New(Item);
    Item^.Handle   := WH;
    Item^.WndText  := WndTxt;
    Item^.PathItem := PathItem;
    Item^.TypeStr  := TypeStr;
    Item^.Parent   := Parent;
    Result := FList.Add(Item);
    //  \
    MsgStr := Format('[##TARGET] %s', [InfoToStr(Item)]);
    if Assigned(MSG_OUT_LVL_1) then MSG_OUT_LVL_1(MsgStr);
end;

//  -----------------------------------------------------------------
//  nhwŃACe폜
procedure   TTargetList.DeleteByHandle(WH: HWND);
var
    Item: PTargetInfo;
    Index: integer;
    MsgStr  : string;
begin
    //  \
    MsgStr := Format('[DLG_WENT] HWND:%10d', [WH]);
    if Assigned(MSG_OUT_LVL_2) then MSG_OUT_LVL_2(MsgStr);
    //  ^[Qbgł?
    Item := GetItem(WH, Index);
    if (Item = nil) then exit;
    //  \
    MsgStr := Format('[  TARGET] %s', [InfoToStr(Item)]);
    if Assigned(MSG_OUT_LVL_1) then MSG_OUT_LVL_1(MsgStr);
    DeleteByIndex(Index);
end;

//  -----------------------------------------------------------------
//  CfbNXwŃACe폜
procedure   TTargetList.DeleteByIndex(Index: integer);
var
    Item: PTargetInfo;
begin
    Item := FList.Items[Index];
    Dispose(Item);
    FList.Delete(Index);
end;

//  -----------------------------------------------------------------
//  nhwŃACe擾
function    TTargetList.GetItem(WH: HWND; var Index: integer): PTargetInfo;
var
    i: integer;
    Item: PTargetInfo;
begin
    Index := -1;
    Result := nil;
    for i := 0 to FList.Count - 1 do
    begin
        Item := FList.Items[i];
        if (Item^.Handle = WH) then
        begin
            Index := i;
            Result := Item;
            break;
        end;
    end;
end;

//  -----------------------------------------------------------------
//  ŌɒǉꂽACe擾
function    TTargetList.GetLast(): PTargetInfo;
begin
    Result := nil;
    if (FList.Count > 0) then Result := FList.Last();
end;

//  -----------------------------------------------------------------
//  RXgN^
constructor TTargetList.Create();
begin
    inherited;
    FList := TList.Create;
end;

//  -----------------------------------------------------------------
//  fXgN^
destructor  TTargetList.Destroy();
begin
    while (FList.Count > 0) do DeleteByIndex(0);
    FList.Free;
    inherited;
end;










//------------------------------------------------------------------------------
(* RXgN^ *)
constructor TClickHereItIs.Create();
begin
    inherited Create;
    //  
    FPreHandle  := 0;
    FPrePath    := '';
    //  nhXg쐬
    FHWndSList := TStringList.Create;
    FTargets := TTargetList.Create;
    // EBhERg[̂ӂ
    FWndHandle := Classes.AllocateHWnd(WndProc);
    // Ƃ肠
    FEnabled := False;
    //  tbN
    HookInitialize();
    //  tbNCXg[
    HookInstall(FWndHandle);
end;

//------------------------------------------------------------------------------
(* fXgN^ *)
destructor  TClickHereItIs.Destroy;
begin
    //  tbNACXg[
    HookUnInstall();
    //  tbNn
    HookFinalize();
    // EBhÊӂ蒆~
    Classes.DeallocateHWnd(FWndHandle);
    //  nhXgj
    FHWndSList.Free;
    FTargets.Free;
    inherited;
end;

//  -------------------------------------------------
//  _CAOǂ
function IsDialog(WH: integer): Boolean;
begin
    Result := (GetClassNameStr(WH) = DLG_CLASS_NAME);
end;

(*
    ===========================================================================
    _CAOꂽǂǂ?
    ===========================================================================
*)
procedure   TClickHereItIs.DoTargetCreate(WH: HWND);
begin
    //  ̃EBhEgbvEBhEǂ
    if (IsTopLevelWindow(WH)) then
    begin
        //  _CAOH
        if IsDialog(WH) then
        begin
            Sleep(ClickConfig.Wait4Check);
            FTargets.Add(WH);
        end;
    end;
end;

(*
    ===========================================================================
    }EXNbNꂽŁBǂ?
    ===========================================================================
*)
procedure   TClickHereItIs.DoTargetHack();
var
    MsgStr: string;
    NewPath: string;
    Item: PTargetInfo;
begin
    //  }EX̃EBhEpXo
    if GetFullPathOfMouse(NewPath) then
    begin
        //  \
        MsgStr := Format('[GET_PATH] PATH:%s', [NewPath]);
        if Assigned(MSG_OUT_LVL_2) then MSG_OUT_LVL_2(MsgStr);

        //  ێĂԍŐV̂̂擾
        Item := FTargets.GetLast();
        if (Item = nil) then exit;

        //  Ȏgݍ킹ƈقȂ邱ƂmF
        if ((NewPath <> FPrePath) or (Item^.Handle <> FPreHandle)) then
        begin
            //  pXݒ
            SetDialogPath(Item^.Handle, NewPath, Item^.PathItem);
            //  \Ă݂
            MsgStr := Format('[**TARGET] PATH:%s | %s', [NewPath, InfoToStr(Item)]);
            if Assigned(MSG_OUT_LVL_1) then MSG_OUT_LVL_1(MsgStr);
            //  L^
            FPreHandle := Item^.Handle;
            FPrePath := NewPath;
        end;
    end;
end;

(*
    ===========================================================================
    _CAOjꂽǂǂ?
    ===========================================================================
*)
procedure   TClickHereItIs.DoTargetDestroy(WH: HWND);
begin
    //  _CAOH
    if IsDialog(WH) then
    begin
        FTargets.DeleteByHandle(WH);
    end;
end;

(*
    ===========================================================================
    EBhEvV[W
    ---------------------------------------------------------------------------
    ms-help://MS.PSDK.1033/winui/winui/windowsuserinterface/windowing/hooks/
    hookreference/hookfunctions/cbtproc.htm
    ===========================================================================
*)
procedure TClickHereItIs.WndProc(var Msg: TMessage);
begin

    if (FEnabled) then
    begin
        case Msg.Msg of
            //  EBhE쐬
            UM_CREATEWND:   DoTargetCreate(Msg.WParam);
            //  EBhEj
            UM_DESTROYWND:  DoTargetDestroy(Msg.WParam);
            //  pXύX
            UM_MOUSEACTION: DoTargetHack();
        end;
    end;

    // ̃bZ[W͒mBǂɂāB
    Msg.Result := DefWindowProc(FWndHandle, Msg.Msg, Msg.wParam, Msg.lParam);
end;

//------------------------------------------------------------------------------
(* 󂯕t *)
procedure   TClickHereItIs.Start();
begin
    FEnabled := True;
end;

//------------------------------------------------------------------------------
(* 󂯕t܂ *)
procedure   TClickHereItIs.Stop();
begin
    FEnabled := False;
end;








//------------------------------------------------------------------------------
(* Winsock *)
var
    WSAData: TWSaData;

initialization

    //  WinsockJn
    WinSockIsActive :=  (WSaStartup($0101, WSAData) = 0)
                    and (WSAData.wVersion = $0101);

finalization

    //  WinsockI
    WSACleanup;

end.

